import { Action } from '@ngrx/store';
import { User } from 'src/app/shared/models/user.model';

/**type of actions*/

export enum UserActionType {

  // action: get all users
  GET_ALL_USERS = '[User] GET ALL USERS',
  GET_ALL_USERS_SUCCESS = '[User] GET-ALL USERS SUCCESS',
  GET_ALL_USERS_ERROR = '[User] GET-ALL USERS ERROR',

  // action: search a user
  SEARCH_A_USER = '[User] SEARCH A USER',
  SEARCH_A_USER_SUCCESS = '[User] SEARCH A USER SUCCESS',
  SEARCH_A_USER_ERROR = '[User] SEARCH A USER ERROR',


  // action of button: create a user form
  CREATE_FORM_ADD_USER = '[User] USER FORM ADD',
  CREATE_FORM_ADD_USER_SUCCESS = '[User] USER FORM ADD SUCCESS',
  CREATE_FORM_ADD_USER_ERROR = '[User] USER FORM ADD ERROR',

  // action of saving user data in the form
  SAVE_USERFORM_ADD = '[User] SAVE USER',
  SAVE_USERFORM_ADD_SUCCESS = '[User] SAVE USER SUCCESS',
  SAVE_USERFORM_ADD_ERROR = '[User] SAVE USER ERROR',

  // action: create form to edit a user
  CREATE_FORM_USER_EDIT = '[User] USER FORM EDIT',
  CREATE_FORM_USER_EDIT_SUCCESS = '[User] USER FORM EDIT SUCCESS',
  CREATE_FORM_USER_EDIT_ERROR = '[User] USER FORM EDIT ERROR',

  // action of updating user from user form
  UPDATE_USER_FORM = '[User] USER FORM UPDATE',
  UPDATE_USER_FORM_SUCCESS = '[User] USER FORM UPDATE SUCCESS',
  UPDATE_USER_FORM_ERROR = '[User] USER FORM UPDATE ERROR',


  // action: delete a user
  DELETE_A_USER = '[User] DELETE A USER',
  DELETE_A_USER_SUCCESS = '[User] DELETE A USER SUCCESS',
  DELETE_A_USER_ERROR = '[User] DELETE A USER ERROR',
}

/**create actions related to a user*/

//get all users actions

export class GetAllUsersAction implements Action {
  type: UserActionType = UserActionType.GET_ALL_USERS;

  constructor(public payload: any) {}
}

export class GetAllUsersActionSuccess implements Action {
  type: UserActionType = UserActionType.GET_ALL_USERS_SUCCESS;
  constructor(public payload: User[]) {}
}

export class GetAllUsersActionError implements Action {
  type: UserActionType = UserActionType.GET_ALL_USERS_ERROR;
  constructor(public payload: string) {}
}

 // Actios of searching a user

export class SearchUsersAction implements Action {
  type: UserActionType = UserActionType.SEARCH_A_USER;

  constructor(public payload: any) {}
}

export class SearchUserActionSuccess implements Action {
  type: UserActionType = UserActionType.SEARCH_A_USER_SUCCESS;
  constructor(public payload: User[]) {}
}

export class SearchUserActionError implements Action {
  type: UserActionType = UserActionType.SEARCH_A_USER_ERROR;
  constructor(public payload: string) {}
}

// Actios of creating a user form to add user

export class CreateFormUserAddAction implements Action {
  type: UserActionType = UserActionType.CREATE_FORM_ADD_USER;
  constructor(public payload: any) {}
}

export class CreateFormUserAddActionSuccess implements Action {
  type: UserActionType = UserActionType.CREATE_FORM_ADD_USER_SUCCESS;
  constructor(public payload: any) {}
}

export class CreateFormUserAddActionError implements Action {
  type: UserActionType = UserActionType.CREATE_FORM_ADD_USER_ERROR;
  constructor(public payload: string) {}
}

//actions of saving a user form data
export class SaveUserFormAction implements Action{
  type: UserActionType = UserActionType.SAVE_USERFORM_ADD;
  constructor(public payload: User){}
}

export class SaveUserFormActionSuccess implements Action{
  type: UserActionType = UserActionType.SAVE_USERFORM_ADD_SUCCESS;
  constructor(public payload: User){}
}

export class SaveUserFormActionError implements Action{
  type: UserActionType = UserActionType.SAVE_USERFORM_ADD_ERROR;
  constructor(public payload: string){}
}

// Actions of creating a user form to edit user

export class CreareFormUserEditAction implements Action {
  type: UserActionType = UserActionType.CREATE_FORM_USER_EDIT;

  constructor(public payload: User) {}
}

export class CreareFormUserEditActionSuccess implements Action {
  type: UserActionType = UserActionType.CREATE_FORM_USER_EDIT_SUCCESS;
  constructor(public payload: User) {}
}

export class CreareFormUserEditActionActionError implements Action {
  type: UserActionType = UserActionType.CREATE_FORM_USER_EDIT_ERROR;
  constructor(public payload: string) {}
}

// action of updating user from user data form

export class UpdateUserFormAction implements Action{
  type: UserActionType = UserActionType.UPDATE_USER_FORM;
  constructor(public payload: User){}
}

export class UpdateUserFormActionSuccess implements Action{
  type: UserActionType = UserActionType.UPDATE_USER_FORM_SUCCESS;
  constructor(public payload: User){}
}

export class UpdateUserFormActionError implements Action{

  type: UserActionType = UserActionType.UPDATE_USER_FORM_ERROR;
  constructor(public payload: string){}
}

// Actions of deleting a user
export class DeleteUsersAction implements Action {
  type: UserActionType = UserActionType.DELETE_A_USER;

  constructor(public payload: User) {}
}

export class DeleteUserActionSuccess implements Action {
  type: UserActionType = UserActionType.DELETE_A_USER_SUCCESS;
  constructor(public payload: User) {}
}

export class DeleteUserActionError implements Action {
  type: UserActionType = UserActionType.DELETE_A_USER_ERROR;
  constructor(public payload: string) {}
}

export type UserActionUnion =
  | GetAllUsersAction
  | GetAllUsersActionSuccess
  | GetAllUsersActionError
  | SearchUsersAction
  | SearchUserActionSuccess
  | SearchUserActionError
  | CreateFormUserAddAction
  | CreateFormUserAddActionSuccess
  | CreateFormUserAddActionError
  | SaveUserFormAction
  | SaveUserFormActionSuccess
  | SaveUserFormActionError
  | CreareFormUserEditAction
  | CreareFormUserEditActionSuccess
  | CreareFormUserEditActionActionError
  | UpdateUserFormAction
  | UpdateUserFormActionSuccess
  | UpdateUserFormActionError
  | DeleteUsersAction
  | DeleteUserActionSuccess
  | DeleteUserActionError;
